# mypy-boto3-inspector

[![PyPI - mypy-boto3-inspector](https://img.shields.io/pypi/v/mypy-boto3-inspector.svg?color=blue)](https://pypi.org/project/mypy-boto3-inspector)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-inspector.svg?color=blue)](https://pypi.org/project/mypy-boto3-inspector)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

Type annotations for
[boto3.Inspector 1.12.39](https://boto3.amazonaws.com/v1/documentation/api/1.12.39/reference/services/inspector.html#Inspector) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 1.0.7](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-inspector](#mypy-boto3-inspector)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

### Type checking

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `Inspector` service.

```bash
python -m pip install boto3-stubs[inspector]

# update installed packages index
mypy_boto3
```

Use `boto3` with `mypy_boto3` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3 import inspector
# alternative import if you do not want to install mypy_boto3 package
# import mypy_boto3_inspector as inspector

# Use this client as usual, now mypy can check if your code is valid.
# Check if your IDE supports function overloads,
# you probably do not need explicit type annotations
# client = boto3.client("inspector")
client: inspector.InspectorClient = boto3.client("inspector")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: inspector.InspectorClient = session.client("inspector")


# Paginators need type annotation on creation
list_assessment_run_agents_paginator: inspector.ListAssessmentRunAgentsPaginator = client.get_paginator("list_assessment_run_agents")
list_assessment_runs_paginator: inspector.ListAssessmentRunsPaginator = client.get_paginator("list_assessment_runs")
list_assessment_targets_paginator: inspector.ListAssessmentTargetsPaginator = client.get_paginator("list_assessment_targets")
list_assessment_templates_paginator: inspector.ListAssessmentTemplatesPaginator = client.get_paginator("list_assessment_templates")
list_event_subscriptions_paginator: inspector.ListEventSubscriptionsPaginator = client.get_paginator("list_event_subscriptions")
list_exclusions_paginator: inspector.ListExclusionsPaginator = client.get_paginator("list_exclusions")
list_findings_paginator: inspector.ListFindingsPaginator = client.get_paginator("list_findings")
list_rules_packages_paginator: inspector.ListRulesPackagesPaginator = client.get_paginator("list_rules_packages")
preview_agents_paginator: inspector.PreviewAgentsPaginator = client.get_paginator("preview_agents")
```

## How it works

Fully automated [builder](https://github.com/vemel/mypy_boto3_builder) carefully generates
type annotations for each service, patiently waiting for `boto3` updates. It delivers
a drop-in type annotations for you and makes sure that:

- All available `boto3` services are covered.
- Each public class and method of every `boto3` service gets valid type annotations
  extracted from the documentation (blame `botocore` docs if types are incorrect).
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) for readability.